/*#define N 1000
#define M 637
#define MATRIX_A 0x9908b0dfUL
#define UPPER_MASK 0x80000000UL
#define LOWER_MASK 0x7fffffffUL
*/

#include <time.h>
#include <assert.h>

#include "rng.h"

static int layer = 0;
static unsigned long mt[2][1000];
static int mti[2]={1001, 0};
static unsigned long mag01[2]={0x0UL, 0x9908b0dfUL};

void RNGPush(unsigned long s)
 {
  assert(layer == 0);
  layer = 1;
  sRNG(s);
 }

void RNGPop(void)
 {
  assert(layer == 1);
  layer = 0;
 }

void sRNG(unsigned long s)
 {
  if(s == 0)
   s = 685171217UL;
  
  mt[layer][0]= s & 0xffffffffUL;
  
  for(mti[layer]=1; mti[layer]<1000; mti[layer]++)
   {
    mt[layer][mti[layer]] = (1812433253UL * (mt[layer][mti[layer]-1] ^ (mt[layer][mti[layer]-1] >> 30)) + mti[layer]); 
    mt[layer][mti[layer]] &= 0xffffffffUL;
   }
 }

unsigned long RNG(void)
 {
  unsigned long y;
  
  if(mti[layer] >= 1000)
   {
    int kk;
    
    if(mti[layer] == 1001)
     sRNG(time(0));
    
    for(kk=0;kk<363;kk++)
     {
      y = (mt[layer][kk]&0x80000000UL)|(mt[layer][kk+1]&0x7fffffffUL);
      mt[layer][kk] = mt[layer][kk+637] ^ (y >> 1) ^ mag01[y & 0x1UL];
     }
    
    for(;kk<999;kk++)
     {
      y = (mt[layer][kk]&0x80000000UL)|(mt[layer][kk+1]&0x7fffffffUL);
      mt[layer][kk] = mt[layer][kk-363] ^ (y >> 1) ^ mag01[y & 0x1UL];
     }
    
    y = (mt[layer][999]&0x80000000UL)|(mt[layer][0]&0x7fffffffUL);
    mt[layer][999] = mt[layer][636] ^ (y >> 1) ^ mag01[y & 0x1UL];
    mti[layer] = 0;
   }
  
  y = mt[layer][mti[layer]++];
  y ^= (y >> 11);
  y ^= (y << 7) & 0x9d2c5680UL;
  y ^= (y << 15) & 0xefc60000UL;
  y ^= (y >> 18);
  return y;
 }
